<?php

/**
 * tercero_ligero actions.
 *
 * @package    cartera
 * @subpackage tercero_ligero
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class tercero_ligeroActions extends sfAPIActions {
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */

    protected $id_name = 'id_mae_ter'; //identificador de la tabla
    protected $id_names = array('id_mae_ter', 'id_nat_jur', 'id_tip_ter', 'id_tipo_doc', 'num_doc'); //llave primaria
    protected $field_names = array('razon_soc', 'pnombre', 'snombre', 'estado_ter', 'papellido', 'sapellido', 'dv'); //campos de la tabla, sin la llave primaria
    protected $check_exists = array('num_doc'); //para verificar que no exista la combinacion de estos campos en la tabla
    protected $table_name = 'INTERCEROS'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = true; //si posee secuencia la tabla


    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_mae_ter'; //identificador unico de la tabla
    protected $has_check_exists = true; //para acutalizar registro si valida campos en check_exists

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */

    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        //Solo valida en el nuevo - 20190315
        if (isset($request['tag_add']) && $request['tag_add'] == 1) {
            $num_doc = $request['num_doc'];

            /*
             *  Validar la operación, ya sea por SQL
             */


            $sql = <<<EOD
        select count(*) as cantidad from interceros
                where num_doc = '$num_doc'
EOD;
            $records = CN_TABLE::executeSQL($sql);

            $terceros = $records[0]['cantidad'];

            if ($terceros > 0) {

                $errors['mensaje'] = "Ya existe un tercero con este numero de documento.";
                $errors['servicio'] = "tercero_ligero";
            }
        }

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
